-- Fibonacci numbers specified by traditional recursive definition
-- and computed efficiently by an infinite list.

fib'pre x = (x >= 0) =:= True

fib'post x y = y =:= g x
  where g x | x == 0 = 0
            | x == 1 = 1
            | otherwise = g (x-1) + g (x-2)

fib x = fiblist 0 1 !! x
 where
  fiblist x y = x : fiblist y (x+y)
