-- straight selection sort with pre/postconditions

perm []     = []
perm (x:xs) = ndinsert x (perm xs)

ndinsert x ys     = x:ys
ndinsert x (y:ys) = y : ndinsert x ys

sorted [] = success
sorted [_] = success
sorted (x:y:ys) = (x<=y)=:=True & sorted (y:ys)

sort'pre _ = success
sort'post x y = y =:= perm x & sorted y

sort :: [Int] -> [Int]
sort [] = []
sort (x:xs) = min : sort rest where (min,rest) = minRest (x:xs)

minRest'pre (_:_) = success
minRest'post (u++[min]++v) y | all (>= min) (u++v)
                             = y =:= (min,perm (u++v))

minRest2 (x:xs) = let m = min x xs in (m, del m (x:xs))
 where min x [] = x
       min x (y:ys) = if x <= y then min x ys else min y ys

       del x (y:ys) = if x == y then ys else y : del x ys

minRest :: [Int] -> (Int,[Int])
minRest (x:xs) = mr x [] xs
 where mr m r [] = (m,r)
       mr m r (y:ys) = if m <= y then mr m (y:r) ys else mr y (m:r) ys

input = [26,18,5,4,16,8,16,22,26,17,21,14,3,26,17]
--input = [26,18,5,4,16,8,16,22,26,17]
